<?php
/* Copyright (c) 1998-2013 ILIAS open source, Extended GPL, see docs/LICENSE */

require_once 'Services/Repository/classes/class.ilObjectPluginAccess.php';
require_once 'class.ilObjQuestionSetPool.php';

/**
 * Class ilObjQuestionSetPoolAccess
 *
 * Date: 23.09.13
 * Time: 13:46
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilObjQuestionSetPoolAccess extends ilObjectPluginAccess
{
	/**
	 * @param string $a_cmd
	 * @param string $a_permission
	 * @param int    $a_ref_id
	 * @param int    $a_obj_id
	 * @param string $a_user_id
	 * @return bool
	 */
	public function _checkAccess($a_cmd, $a_permission, $a_ref_id, $a_obj_id, $a_user_id = '')
	{
		/**
		 * @var $ilUser   ilObjUser
		 * @var $ilAccess ilAccessHandler
		 */
		global $ilUser, $ilAccess;

		if(!$a_user_id)
		{
			$a_user_id = $ilUser->getId();
		}

		switch($a_permission)
		{
			case 'read':
				if(
					!ilObjQuestionSetPoolAccess::checkOnline($a_obj_id) &&
					!$ilAccess->checkAccessOfUser($a_user_id, 'write', '', $a_ref_id)
				)
				{
					return false;
				}
				return true;
		}

		return true;
	}

	/**
	 * @param int $a_obj_id
	 */
	public static function checkOnline($a_obj_id)
	{
		return ilObjQuestionSetPool::getOnlineStatusByObjId($a_obj_id);
	}

	/**
	 * @param array $a_obj_ids
	 * @param array $a_ref_ids
	 */
	static function _preloadData($a_obj_ids, $a_ref_ids)
	{
		ilObjQuestionSetPool::preloadDataForLists($a_obj_ids, $a_ref_ids);
	}
}
