<?php

/**
 * Class ilPluginModelList
 *
 * Date: 06.11.13
 * Time: 11:24
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
abstract class ilPluginModelList
{

	/**
	 * @var ilDB
	 */
	protected $db;

	/**
	 * @var array
	 */
	private $data;

	/**
	 * @var boolean
	 */
	protected $loaded;

	public function __construct()
	{
		global $DIC;

		$this->db = $DIC->database();
	}


	/**
	 * @return array
	 */
	public function getData()
	{
		if(!$this->isLoaded())
		{
			$data = $this->loadData();
			$this->data = $this->createObjectsFromData($data);
			$this->setLoaded(true);
		}

		return $this->data;
	}

	/**
	 * @param boolean $loaded
	 */
	public function setLoaded($loaded)
	{
		$this->loaded = $loaded;
	}

	/**
	 * @return boolean
	 */
	public function isLoaded()
	{
		return $this->loaded;
	}

	/**
	 * @param array $params
	 * @param array $filter
	 *
	 * @return array
	 */
	abstract public function loadData($params = array(), $filter = array());

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	abstract public function createObjectsFromData($data);
}
 