<?php

require_once 'abstract.ilPluginTableDatabaseDataProvider.php';

/**
 * Class ilQuestionSetPoolSkillQuestionListProvider
 *
 * @author  Thomas Joußen <tjoussen@databay.de>
 * @since   01.04.15
 */
class ilQuestionSetPoolSkillQuestionListProvider extends ilPluginTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		return join(',', array('title','question_index','question_fi'));
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return 'rep_robj_xqsp_qs_qst';
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getJoinPart()
	{
		return join(' ', array(
			'INNER JOIN rep_robj_xqsp_qs ON rep_robj_xqsp_qs.id = rep_robj_xqsp_qs_qst.questionset_fi',
	   ));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return $this->db->equals('rep_robj_xqsp_qs.questionsetpool_fi', $filter['questionsetpool_fi'], 'integer');
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return '';
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return '';
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return 'rep_robj_xqsp_qs.title, question_index ASC';
	}
}
 