<?php

/**
 * Class ilQuestionSetPoolInfoBox
 *
 * Date: 05.12.13
 * Time: 11:40
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
abstract class ilQuestionSetPoolInfoBox {

	/**
	 * @param $plugin
	 *
	 * @return string
	 * @internal param \ilQuestionSetPoolNode $model
	 */
	public static function render($plugin)
	{
		$template = new ilTemplate("tpl.il_xqsp_sentential_logic.html", true, true, "Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool");

		$template->setVariable("HEADER", $plugin->txt("info_sentential_logic"));
		$template->setVariable("GENERAL_EXPRESSIONS", $plugin->txt("general_expressions"));
		$template->setVariable("QUESTION_SPECIFIC_EXPRESSIONS", $plugin->txt("question_specific_expressions"));

		$template->setVariable("LOGICAL_AND", $plugin->txt("logical_and"));
		$template->setVariable("LOGICAL_OR", $plugin->txt("logical_or"));
		$template->setVariable("NEGATION", $plugin->txt("negation"));
		$template->setVariable("BRACKETS", $plugin->txt("brackets"));
		$template->setVariable("QUESTION_INDEX", $plugin->txt("question_index"));
		$template->setVariable("ANSWER_INDEX_OF_QUESTION_INDEX", $plugin->txt("answer_index_of_question_index"));

		require_once "./Modules/TestQuestionPool/classes/class.ilOperatorsExpressionMapping.php";

		foreach (ilOperatorsExpressionMapping::getAll() as $expression => $operators)
		{
			$template->setCurrentBlock("expression_type");
			$template->setVariable("EXPRESSION", $expression);
			$template->setVariable("EXPRESSION_DESCRIPTION", $plugin->txt("expression_type_" . $expression));
			$template->setVariable("OPERATORS", join(", ", $operators));
			$template->parseCurrentBlock();
		}

		return $template->get();
	}
}
 