<?php

require_once './Modules/TestQuestionPool/classes/class.ilAssQuestionList.php';

/**
 * Class ilQuestionSetPoolSkillAssQuestionList
 *
 * @author  Thomas Joußen <tjoussen@databay.de>
 * @since   01.04.15
 */
class ilQuestionSetPoolSkillAssQuestionList extends ilAssQuestionList
{

	/**
	 * @var array;
	 */
	protected $orderSequence;

	/**
	 * @var ilPluginTableDatabaseDataProvider
	 */
	protected $provider;

	/**
	 * @param ilDBInterface $db
	 * @param ilLanguage    $lng
	 * @param ilPluginAdmin $pluginAdmin
	 */
	public function __construct(ilDBInterface $db, ilLanguage $lng, ilPluginAdmin $pluginAdmin)
	{
		$this->orderSequence = array();

		parent::__construct($db, $lng, $pluginAdmin);
	}

	/**
	 * @param ilPluginTableDatabaseDataProvider $provider
	 */
	public function setProvider(ilPluginTableDatabaseDataProvider $provider)
	{
		$this->provider = $provider;
	}

	public function load()
	{
		parent::load();

		$data = $this->provider->loadData(array('questionsetpool_fi' => $this->getParentObjId()));

		foreach($data as $row)
		{
			$this->orderSequence[] = $row['question_fi'];
			$questionId = $row['question_fi'];
			if(array_key_exists($questionId, $this->questions))
			{
				$title = $this->questions[$questionId]['title'];
				$this->questions[$questionId]['title'] = '(Q'. $row['question_index']. ') '. $title . ' - ' . $row['title'];
			}
		}
	}

	/**
	 * @return array
	 */
	public function getOrderSequence()
	{
		return $this->orderSequence;
	}
}