<#1>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_data"))
{
	$fields = array(
		'id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'is_online' => array(
			'type' => 'integer',
			'length' => '1',
			'notnull' => false
		)
	);
	$ilDB->createTable("rep_robj_xqsp_data", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_data", array("id"));
}
?>
<#2>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_question"))
{
	$fields = array(
		'questionsetpool_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'question_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		)
	);
	$ilDB->createTable("rep_robj_xqsp_question", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_question", array("questionsetpool_fi", "question_fi"));
}
?>
<#3>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_qs"))
{
	$fields = array(
		'id' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => true
		),
		'questionsetpool_fi' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => true
		),
		'title' => array(
			'type' => 'text',
			'length' => 255
		),
		'description' => array(
			'type' => 'text',
			'length' => 4000
		)
	);
	$ilDB->createTable("rep_robj_xqsp_qs", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_qs", array("id"));
	$ilDB->createSequence("rep_robj_xqsp_qs");
}
?>
<#4>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_qs_qst"))
{
	$fields = array(
		'questionset_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'question_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		)
	);
	$ilDB->createTable("rep_robj_xqsp_qs_qst", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_qs_qst", array("questionset_fi", "question_fi"));
}
?>
<#5>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_qs_qst", "question_index"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_qs_qst", "question_index", array(
		'type' => 'integer',
		'length' => '4',
		'notnull' => true
	));
}
?>
<#6>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_path"))
{
	$fields = array(
		'id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'title' => array(
			'type' => 'text',
			'length' => 255
		),
		'questionset_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
	);
	$ilDB->createTable("rep_robj_xqsp_path", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_path", array("id"));
	$ilDB->createSequence("rep_robj_xqsp_path");
}
?>
<#7>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_node"))
{
	$fields = array(
		'id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'question_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'path_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'node_index' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'initial_condition' => array(
			'type' => 'text',
			'length' => '4000',
		),
	);
	$ilDB->createTable("rep_robj_xqsp_node", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_node", array("id"));
	$ilDB->createSequence("rep_robj_xqsp_node");
}
?>
<#8>
<?php
if(!$ilDB->tableExists("rep_robj_xqsp_jmp_con"))
{
	$fields = array(
		'id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'jump_condition' => array(
			'type' => 'text',
			'length' => 4000
		),
		'node_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'question_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
	);
	$ilDB->createTable("rep_robj_xqsp_jmp_con", $fields);
	$ilDB->addPrimaryKey("rep_robj_xqsp_jmp_con", array("id"));
	$ilDB->createSequence("rep_robj_xqsp_jmp_con");
}
?>
<#9>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_qs", "is_online"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_qs", "is_online", array(
			'type' => 'integer',
			'length' => '1',
			'notnull' => false
		));
}
?>
<#10>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_qs", "original_id"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_qs", "original_id", array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		));
}
?>
<#11>
<?php
if($ilDB->tableExists("rep_robj_xqsp_jmp_con"))
{
	$ilDB->modifyTableColumn("rep_robj_xqsp_jmp_con", "question_fi", array(
			"type" => "integer",
			"length" => 4,
			"notnull" => false
	));
}
?>
<#12>
<?php
$query = "SELECT od.obj_id FROM object_data od LEFT JOIN rep_robj_xqsp_data xqsp ON xqsp.id = od.obj_id WHERE xqsp.id IS NULL AND od.type = " . $ilDB->quote('xqsp', 'text');
$res = $ilDB->query($query);
while($row = $ilDB->fetchAssoc($res))
{
	$ilDB->manipulateF(
		'INSERT INTO rep_robj_xqsp_data (id) VALUES (%s)',
		array('integer'),
		array($row['obj_id'])
	);
}
?>
<#13>
<?php
if($ilDB->tableExists('rep_robj_xqsp_question'))
{
	$ilDB->dropTable('rep_robj_xqsp_question');
}
?>
<#14>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_path", "path_index"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_path", "path_index", array(
		'type' => 'integer',
		'length' => '4',
		'notnull' => false
	));
}
?>
<#15>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_node", "dominant_scoring"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_node", "dominant_scoring", array(
		'type' => 'integer',
		'length' => '4',
		'notnull' => true
	));
}
?>
<#16>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "repititions"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_jmp_con", "repititions", array(
		'type' => 'integer',
		'length' => '4',
		'notnull' => true
	));
}
?>
<#17>
<?php
if($ilDB->tableColumnExists("rep_robj_xqsp_qs", "is_online"))
{
	$ilDB->dropTableColumn("rep_robj_xqsp_qs", "is_online");
}
?>
<#18>
<?php
/** @var ilDB $ilDB */
if($ilDB->tableColumnExists("rep_robj_xqsp_node", "dominant_scoring"))
{
	$ilDB->modifyTableColumn("rep_robj_xqsp_node", "dominant_scoring", array(
	  "type" => "integer",
	  "length" => 4,
	  "notnull" => false
	));
}
?>
<#19>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "sorting"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_jmp_con", "sorting", array(
		"type" => "integer",
		"length" => 4,
		"notnull" => false
	));

	$ilDB->query("UPDATE rep_robj_xqsp_jmp_con SET sorting = id");
}
?>
<#20>
<?php
if($ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "repititions"))
{
	$ilDB->modifyTableColumn("rep_robj_xqsp_jmp_con", "repititions", array(
		"type" => "integer",
		"length" => 4,
		"notnull" => false
	));

	$ilDB->query("UPDATE rep_robj_xqsp_jmp_con SET repititions = NULL WHERE repititions = 0");
}
?>
<#21>
<?php
if($ilDB->tableExists('rep_robj_xqsp_node'))
{
	if(!$ilDB->tableColumnExists("rep_robj_xqsp_node", "true_feedback"))
	{
		$ilDB->addTableColumn('rep_robj_xqsp_node', 'true_feedback',
			array("type" => "clob",
				  "notnull" => false,
				  "default" => null));
	}

	if(!$ilDB->tableColumnExists("rep_robj_xqsp_node", "false_feedback"))
	{
		$ilDB->addTableColumn('rep_robj_xqsp_node', 'false_feedback',
			array("type" => "clob",
				  "notnull" => false,
				  "default" => null));
	}
}
?>
<#22>
<?php
if($ilDB->tableExists('rep_robj_xqsp_jmp_con'))
{
	if(!$ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "true_feedback"))
	{
		$ilDB->addTableColumn('rep_robj_xqsp_jmp_con', 'true_feedback',
			array("type" => "clob",
				"notnull" => false,
				"default" => null));
	}

	if(!$ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "true_jmp_feedback"))
	{
		$ilDB->addTableColumn('rep_robj_xqsp_jmp_con', 'true_jmp_feedback',
			array("type" => "clob",
				  "notnull" => false,
				  "default" => null));
	}
	
	if(!$ilDB->tableColumnExists("rep_robj_xqsp_jmp_con", "false_feedback"))
	{
		$ilDB->addTableColumn('rep_robj_xqsp_jmp_con', 'false_feedback',
			array("type" => "clob",
				  "notnull" => false,
				  "default" => null));
	}
}
?>
<#23>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xqsp_data", "skill_service"))
{
	$ilDB->addTableColumn("rep_robj_xqsp_data", "skill_service", array(
		'type' => 'integer',
		'length' => '1',
		'notnull' => false
	));
}
?>
<#24>
<?php
//
?>
<#25>
<?php
if ($ilDB->tableExists('rep_robj_xqsp_jmp_con')) {
    $ilDB->addIndex("rep_robj_xqsp_jmp_con", array("node_fi"), "i1");
    $ilDB->addIndex("rep_robj_xqsp_jmp_con", array("question_fi"), "i2");
}

if ($ilDB->tableExists('rep_robj_xqsp_node')) {
    $ilDB->addIndex("rep_robj_xqsp_node", array("question_fi"), "i1");
    $ilDB->addIndex("rep_robj_xqsp_node", array("path_fi"), "i2");
}
?>
<#26>
<?php
?>