<?php

require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/test/Mocks/ilPluginTableDatabaseDataProviderMock.php";

/**
 * Class ilPluginTableDatabaseDataProviderTest
 *
 * Date: 24.09.13
 * Time: 13:33
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilPluginTableDatabaseDataProviderTest extends PHPUnit_Framework_TestCase {

	/**
	 * @var ilQuestionSetPoolQuestionsBrowserProvider
	 */
	protected $provider;

	public function setUp()
	{
		global $DIC;
		$ilDB = $DIC->database();

		$ilDB_mock = $this->getMockBuilder("ilDB")->getMock();
		$ilDB_mock
		->expects($this->any())
		->method("quote")
		->with(2)
		->will($this->returnValue(2));

		$ilDB = $ilDB_mock;

		$this->provider = new ilPluginTableDatabaseDataProviderMock();
	}

	public function testIsLoaded()
	{
		$this->assertFalse($this->provider->isLoaded(), "The Provider isn't loaded");
		$this->provider->setLoaded(true);
		$this->assertTrue($this->provider->isLoaded(), "The Provider is loaded");
	}

	
}
